// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::GraphColumn;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlGraphModel")]
    pub struct GraphModel(Object<ffi::DzlGraphModel, ffi::DzlGraphModelClass>);

    match fn {
        type_ => || ffi::dzl_graph_view_model_get_type(),
    }
}

impl GraphModel {
    pub const NONE: Option<&'static GraphModel> = None;

    #[doc(alias = "dzl_graph_view_model_new")]
    pub fn new() -> GraphModel {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::dzl_graph_view_model_new()) }
    }

    //#[doc(alias = "dzl_graph_view_model_iter_get")]
    //pub fn iter_get(iter: /*Ignored*/&mut GraphModelIter, first_column: i32, : /*Unknown conversion*//*Unimplemented*/Basic: VarArgs) {
    //    unsafe { TODO: call ffi:dzl_graph_view_model_iter_get() }
    //}

    //#[doc(alias = "dzl_graph_view_model_iter_get_timestamp")]
    //pub fn iter_get_timestamp(iter: /*Ignored*/&mut GraphModelIter) -> i64 {
    //    unsafe { TODO: call ffi:dzl_graph_view_model_iter_get_timestamp() }
    //}

    //#[doc(alias = "dzl_graph_view_model_iter_get_value")]
    //pub fn iter_get_value(iter: /*Ignored*/&mut GraphModelIter, column: u32, value: &mut glib::Value) {
    //    unsafe { TODO: call ffi:dzl_graph_view_model_iter_get_value() }
    //}

    //#[doc(alias = "dzl_graph_view_model_iter_next")]
    //pub fn iter_next(iter: /*Ignored*/&mut GraphModelIter) -> bool {
    //    unsafe { TODO: call ffi:dzl_graph_view_model_iter_next() }
    //}

    //#[doc(alias = "dzl_graph_view_model_iter_set")]
    //pub fn iter_set(iter: /*Ignored*/&mut GraphModelIter, first_column: i32, : /*Unknown conversion*//*Unimplemented*/Basic: VarArgs) {
    //    unsafe { TODO: call ffi:dzl_graph_view_model_iter_set() }
    //}

    //#[cfg(feature = "v3_30")]
    //#[cfg_attr(docsrs, doc(cfg(feature = "v3_30")))]
    //#[doc(alias = "dzl_graph_view_model_iter_set_value")]
    //pub fn iter_set_value(iter: /*Ignored*/&mut GraphModelIter, column: u32, value: &glib::Value) {
    //    unsafe { TODO: call ffi:dzl_graph_view_model_iter_set_value() }
    //}
}

impl Default for GraphModel {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::GraphModel>> Sealed for T {}
}

pub trait GraphModelExt: IsA<GraphModel> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_graph_view_model_add_column")]
    fn add_column(&self, column: &GraphColumn) -> u32 {
        unsafe {
            ffi::dzl_graph_view_model_add_column(
                self.as_ref().to_glib_none().0,
                column.to_glib_none().0,
            )
        }
    }

    #[doc(alias = "dzl_graph_view_model_get_end_time")]
    #[doc(alias = "get_end_time")]
    fn end_time(&self) -> i64 {
        unsafe { ffi::dzl_graph_view_model_get_end_time(self.as_ref().to_glib_none().0) }
    }

    //#[doc(alias = "dzl_graph_view_model_get_iter_first")]
    //#[doc(alias = "get_iter_first")]
    //fn is_iter_first(&self, iter: /*Ignored*/&mut GraphModelIter) -> bool {
    //    unsafe { TODO: call ffi:dzl_graph_view_model_get_iter_first() }
    //}

    //#[doc(alias = "dzl_graph_view_model_get_iter_last")]
    //#[doc(alias = "get_iter_last")]
    //fn is_iter_last(&self, iter: /*Ignored*/&mut GraphModelIter) -> bool {
    //    unsafe { TODO: call ffi:dzl_graph_view_model_get_iter_last() }
    //}

    #[doc(alias = "dzl_graph_view_model_get_max_samples")]
    #[doc(alias = "get_max_samples")]
    fn max_samples(&self) -> u32 {
        unsafe { ffi::dzl_graph_view_model_get_max_samples(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "dzl_graph_view_model_get_n_columns")]
    #[doc(alias = "get_n_columns")]
    fn n_columns(&self) -> u32 {
        unsafe { ffi::dzl_graph_view_model_get_n_columns(self.as_ref().to_glib_none().0) }
    }

    //#[doc(alias = "dzl_graph_view_model_get_timespan")]
    //#[doc(alias = "get_timespan")]
    //fn timespan(&self) -> /*Ignored*/glib::TimeSpan {
    //    unsafe { TODO: call ffi:dzl_graph_view_model_get_timespan() }
    //}

    //#[doc(alias = "dzl_graph_view_model_push")]
    //fn push(&self, iter: /*Ignored*/GraphModelIter, timestamp: i64) {
    //    unsafe { TODO: call ffi:dzl_graph_view_model_push() }
    //}

    #[doc(alias = "dzl_graph_view_model_set_max_samples")]
    fn set_max_samples(&self, n_rows: u32) {
        unsafe {
            ffi::dzl_graph_view_model_set_max_samples(self.as_ref().to_glib_none().0, n_rows);
        }
    }

    //#[doc(alias = "dzl_graph_view_model_set_timespan")]
    //fn set_timespan(&self, timespan: /*Ignored*/glib::TimeSpan) {
    //    unsafe { TODO: call ffi:dzl_graph_view_model_set_timespan() }
    //}

    #[doc(alias = "value-max")]
    fn value_max(&self) -> f64 {
        ObjectExt::property(self.as_ref(), "value-max")
    }

    #[doc(alias = "value-max")]
    fn set_value_max(&self, value_max: f64) {
        ObjectExt::set_property(self.as_ref(), "value-max", value_max)
    }

    #[doc(alias = "value-min")]
    fn value_min(&self) -> f64 {
        ObjectExt::property(self.as_ref(), "value-min")
    }

    #[doc(alias = "value-min")]
    fn set_value_min(&self, value_min: f64) {
        ObjectExt::set_property(self.as_ref(), "value-min", value_min)
    }

    #[doc(alias = "changed")]
    fn connect_changed<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn changed_trampoline<P: IsA<GraphModel>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlGraphModel,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(GraphModel::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"changed\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    changed_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "max-samples")]
    fn connect_max_samples_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_max_samples_trampoline<
            P: IsA<GraphModel>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlGraphModel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(GraphModel::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::max-samples\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_max_samples_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "timespan")]
    fn connect_timespan_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_timespan_trampoline<P: IsA<GraphModel>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlGraphModel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(GraphModel::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::timespan\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_timespan_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "value-max")]
    fn connect_value_max_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_value_max_trampoline<
            P: IsA<GraphModel>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlGraphModel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(GraphModel::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::value-max\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_value_max_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "value-min")]
    fn connect_value_min_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_value_min_trampoline<
            P: IsA<GraphModel>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlGraphModel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(GraphModel::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::value-min\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_value_min_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<GraphModel>> GraphModelExt for O {}

impl fmt::Display for GraphModel {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("GraphModel")
    }
}
